/* Copy stdin to stdout, substituting any %s for the current timestamp
 * (hacked out of makeDNS.c).  The idea is that the HS-class header should
 * just $INCLUDE anything it needs, which will have been generated separately.
 */

/*
 * $Id: makeDNSserial.c,v 1.4 2002/06/17 12:53:02 gdmr Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>

#define LINEBUFFER 120
#define LOG "Log.DNS"

static char *RCS_revision = "$Revision: 1.4 $";

int main()
{	static struct passwd *pwd;
	char *pwname;
	time_t tt;
	struct tm *ttm;
	char *t;
	char *ln;
	char stamp[20];
	FILE *l;
	char buffer[LINEBUFFER];

        pwd = getpwuid(getuid());
        endpwent();
	if (pwd) pwname = pwd->pw_name;
	else pwname = "UNKNOWN";
	tt = time(NULL);
	ttm = localtime(&tt);
	(void) sprintf(stamp, "%d%3.3d%3.3d",
		1900 + ttm->tm_year, ttm->tm_yday,
		((60 * ttm->tm_hour) + ttm->tm_min) >> 1);
	t = asctime(ttm);
	t[strlen(t) - 1] = '\0';
        ln = getenv("LOGNAME");
	if (!ln) {
		fprintf(stderr, "** LOGNAME not set??\n");
		ln = "*unknown*";
	}
        if (l = fopen(LOG, "a")) {
                fprintf(l, "Generated by %s (%s) on %s using makeHS %s\n",
			pwname, ln, t, RCS_revision);
                fclose(l);
        }

	(void) printf(";; Generated by %s (%s) on %s\n",
			pwd->pw_name, ln, t);
	(void) printf(";; using makeDNSserial %s\n",
			RCS_revision);

	for (;;) {
		if (fgets(buffer, LINEBUFFER, stdin) == NULL) break;
		(void) printf(buffer, stamp);
	}
	(void) printf("\n@\tIN\tTXT\t\"Generated by %s (%s) on %s using makeDNSserial %s\"\n",
			pwd->pw_name, ln, t, RCS_revision);
	return 0;
}

/*
 * $Log: makeDNSserial.c,v $
 * Revision 1.4  2002/06/17 12:53:02  gdmr
 * HS -> IN; tidy some informational output.
 *
 * Revision 1.3  1998/09/08 10:59:06  gdmr
 * Report makeHS revision number
 *
 *
 */
